Subject: bug#630: exim 4.94.5 installation configures IPv6 by default on IPv4 only machines

From: [email-masked]
Date: Sat, 13 Nov 2021 17:31:42 -0300

Package: exim4
Version: 4.92-5
Severity: grave

I've previously reported this bug to Debian:

https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=999612

Unfortunately, a *single* reference to Devuan slipped by my editing.
As a result, the bug report was instantly/swiftly closed by the chap 
in charge with the reply being:

"Well, you are running an unsupported setup."

I really don't have time to set up a Debian installation to prove it 
is *also* a bug for Debian and probably every Debian based 
distribution. 

I had also previously exchanged opinions with respect to this problem 
on the exim-users list but without any success.

https://lists.exim.org/lurker/thread/20211113.163548.7007ca8c.en.html

So ...
Exim will not fix it because they actually don't think it is a bug.

Debian won't fix it because the person reporting the bug is running 
Exim under an unsupported configuration.

The truth of the matter is this:

Exim, as it comes straight from the official Debian repository, will 
install itself to use IPv6 *by default* in a system where the 
settings *explicitly* disable the IPv6 protocol.  

ie:

1.
The kernel command line includes the bit needed to disable ipv6 at
boot:

[code]
ipv6.disable=1
[/code]

2.
The /etc/hosts file has no machine readable IPv6 lines:

[code]
groucho@devuan:~$ cat /etc/hosts
#
127.0.0.1         localhost  devuan
#
# remmed to disable ip6
#::1                 localhost       ip6-localhost ip6-loopback
#fe00::0          ip6-localnet
#fe00::0          ip6-mcastprefix
#fe02::1          ip6-allnodes
#fe02::1          ip6-allrouters
groucho@devuan:~$
[/code]

3.
The /etc/ssh/ssh_config file includes the line needed to disable
ipv6:

[code]
groucho@devuan:~$ cat /etc/ssh/ssh_config
--- snip ---
AddressFamily inet     # instead of 'any' or 'inet6'
--- snip ---
groucho@devuan:~$
[/code]

In doing so, when Exim starts it generates a paniclog message:

[code]
IPv6 socket creation failed: Address family not supported by protocol
[/code]

Also, in a machine such as mine, running a VBox VM with a DNS (both 
configured explicitly disabling IPv6) it will also generate a 30s 
delay at boot while Exim makes an AAAA query to the DNS which (quite 
obviously) it won't answer.  

If this is not a bug ...

I'd appreciate any comments you'd care to make.

Thanks in advance.

Best,

A.